/**
 * Autogenerated by Avro
 *
 * DO NOT EDIT DIRECTLY
 */
package org.datastream.khodza.model.avro.t_scele_public_mdl_asynchronous;

import org.apache.avro.specific.SpecificData;

@SuppressWarnings("all")
@org.apache.avro.specific.AvroGenerated
public class AsynchronousValue extends org.apache.avro.specific.SpecificRecordBase implements org.apache.avro.specific.SpecificRecord {
  private static final long serialVersionUID = -7429995845650459766L;
  public static final org.apache.avro.Schema SCHEMA$ = new org.apache.avro.Schema.Parser().parse("{\"type\":\"record\",\"name\":\"AsynchronousValue\",\"namespace\":\"org.datastream.khodza.model.avro.t_scele_public_mdl_asynchronous\",\"fields\":[{\"name\":\"id\",\"type\":{\"type\":\"long\",\"connect.default\":0},\"default\":0},{\"name\":\"attemptid\",\"type\":\"long\"},{\"name\":\"cmid\",\"type\":\"long\"},{\"name\":\"courseid\",\"type\":\"long\"},{\"name\":\"userid\",\"type\":\"long\"},{\"name\":\"activitycode\",\"type\":{\"type\":\"int\",\"connect.type\":\"int16\"}},{\"name\":\"activity\",\"type\":[\"null\",\"string\"],\"default\":null},{\"name\":\"timestamp\",\"type\":\"long\"}],\"connect.name\":\"t_scele.public.mdl_asynchronous.AsynchronousValue\"}");
  public static org.apache.avro.Schema getClassSchema() { return SCHEMA$; }
  @Deprecated public long id;
  @Deprecated public long attemptid;
  @Deprecated public long cmid;
  @Deprecated public long courseid;
  @Deprecated public long userid;
  @Deprecated public int activitycode;
  @Deprecated public java.lang.CharSequence activity;
  @Deprecated public long timestamp;

  /**
   * Default constructor.  Note that this does not initialize fields
   * to their default values from the schema.  If that is desired then
   * one should use <code>newBuilder()</code>.
   */
  public AsynchronousValue() {}

  /**
   * All-args constructor.
   * @param id The new value for id
   * @param attemptid The new value for attemptid
   * @param cmid The new value for cmid
   * @param courseid The new value for courseid
   * @param userid The new value for userid
   * @param activitycode The new value for activitycode
   * @param activity The new value for activity
   * @param timestamp The new value for timestamp
   */
  public AsynchronousValue(java.lang.Long id, java.lang.Long attemptid, java.lang.Long cmid, java.lang.Long courseid, java.lang.Long userid, java.lang.Integer activitycode, java.lang.CharSequence activity, java.lang.Long timestamp) {
    this.id = id;
    this.attemptid = attemptid;
    this.cmid = cmid;
    this.courseid = courseid;
    this.userid = userid;
    this.activitycode = activitycode;
    this.activity = activity;
    this.timestamp = timestamp;
  }

  public org.apache.avro.Schema getSchema() { return SCHEMA$; }
  // Used by DatumWriter.  Applications should not call.
  public java.lang.Object get(int field$) {
    switch (field$) {
    case 0: return id;
    case 1: return attemptid;
    case 2: return cmid;
    case 3: return courseid;
    case 4: return userid;
    case 5: return activitycode;
    case 6: return activity;
    case 7: return timestamp;
    default: throw new org.apache.avro.AvroRuntimeException("Bad index");
    }
  }

  // Used by DatumReader.  Applications should not call.
  @SuppressWarnings(value="unchecked")
  public void put(int field$, java.lang.Object value$) {
    switch (field$) {
    case 0: id = (java.lang.Long)value$; break;
    case 1: attemptid = (java.lang.Long)value$; break;
    case 2: cmid = (java.lang.Long)value$; break;
    case 3: courseid = (java.lang.Long)value$; break;
    case 4: userid = (java.lang.Long)value$; break;
    case 5: activitycode = (java.lang.Integer)value$; break;
    case 6: activity = (java.lang.CharSequence)value$; break;
    case 7: timestamp = (java.lang.Long)value$; break;
    default: throw new org.apache.avro.AvroRuntimeException("Bad index");
    }
  }

  /**
   * Gets the value of the 'id' field.
   * @return The value of the 'id' field.
   */
  public java.lang.Long getId() {
    return id;
  }

  /**
   * Sets the value of the 'id' field.
   * @param value the value to set.
   */
  public void setId(java.lang.Long value) {
    this.id = value;
  }

  /**
   * Gets the value of the 'attemptid' field.
   * @return The value of the 'attemptid' field.
   */
  public java.lang.Long getAttemptid() {
    return attemptid;
  }

  /**
   * Sets the value of the 'attemptid' field.
   * @param value the value to set.
   */
  public void setAttemptid(java.lang.Long value) {
    this.attemptid = value;
  }

  /**
   * Gets the value of the 'cmid' field.
   * @return The value of the 'cmid' field.
   */
  public java.lang.Long getCmid() {
    return cmid;
  }

  /**
   * Sets the value of the 'cmid' field.
   * @param value the value to set.
   */
  public void setCmid(java.lang.Long value) {
    this.cmid = value;
  }

  /**
   * Gets the value of the 'courseid' field.
   * @return The value of the 'courseid' field.
   */
  public java.lang.Long getCourseid() {
    return courseid;
  }

  /**
   * Sets the value of the 'courseid' field.
   * @param value the value to set.
   */
  public void setCourseid(java.lang.Long value) {
    this.courseid = value;
  }

  /**
   * Gets the value of the 'userid' field.
   * @return The value of the 'userid' field.
   */
  public java.lang.Long getUserid() {
    return userid;
  }

  /**
   * Sets the value of the 'userid' field.
   * @param value the value to set.
   */
  public void setUserid(java.lang.Long value) {
    this.userid = value;
  }

  /**
   * Gets the value of the 'activitycode' field.
   * @return The value of the 'activitycode' field.
   */
  public java.lang.Integer getActivitycode() {
    return activitycode;
  }

  /**
   * Sets the value of the 'activitycode' field.
   * @param value the value to set.
   */
  public void setActivitycode(java.lang.Integer value) {
    this.activitycode = value;
  }

  /**
   * Gets the value of the 'activity' field.
   * @return The value of the 'activity' field.
   */
  public java.lang.CharSequence getActivity() {
    return activity;
  }

  /**
   * Sets the value of the 'activity' field.
   * @param value the value to set.
   */
  public void setActivity(java.lang.CharSequence value) {
    this.activity = value;
  }

  /**
   * Gets the value of the 'timestamp' field.
   * @return The value of the 'timestamp' field.
   */
  public java.lang.Long getTimestamp() {
    return timestamp;
  }

  /**
   * Sets the value of the 'timestamp' field.
   * @param value the value to set.
   */
  public void setTimestamp(java.lang.Long value) {
    this.timestamp = value;
  }

  /**
   * Creates a new AsynchronousValue RecordBuilder.
   * @return A new AsynchronousValue RecordBuilder
   */
  public static org.datastream.khodza.model.avro.t_scele_public_mdl_asynchronous.AsynchronousValue.Builder newBuilder() {
    return new org.datastream.khodza.model.avro.t_scele_public_mdl_asynchronous.AsynchronousValue.Builder();
  }

  /**
   * Creates a new AsynchronousValue RecordBuilder by copying an existing Builder.
   * @param other The existing builder to copy.
   * @return A new AsynchronousValue RecordBuilder
   */
  public static org.datastream.khodza.model.avro.t_scele_public_mdl_asynchronous.AsynchronousValue.Builder newBuilder(org.datastream.khodza.model.avro.t_scele_public_mdl_asynchronous.AsynchronousValue.Builder other) {
    return new org.datastream.khodza.model.avro.t_scele_public_mdl_asynchronous.AsynchronousValue.Builder(other);
  }

  /**
   * Creates a new AsynchronousValue RecordBuilder by copying an existing AsynchronousValue instance.
   * @param other The existing instance to copy.
   * @return A new AsynchronousValue RecordBuilder
   */
  public static org.datastream.khodza.model.avro.t_scele_public_mdl_asynchronous.AsynchronousValue.Builder newBuilder(org.datastream.khodza.model.avro.t_scele_public_mdl_asynchronous.AsynchronousValue other) {
    return new org.datastream.khodza.model.avro.t_scele_public_mdl_asynchronous.AsynchronousValue.Builder(other);
  }

  /**
   * RecordBuilder for AsynchronousValue instances.
   */
  public static class Builder extends org.apache.avro.specific.SpecificRecordBuilderBase<AsynchronousValue>
    implements org.apache.avro.data.RecordBuilder<AsynchronousValue> {

    private long id;
    private long attemptid;
    private long cmid;
    private long courseid;
    private long userid;
    private int activitycode;
    private java.lang.CharSequence activity;
    private long timestamp;

    /** Creates a new Builder */
    private Builder() {
      super(SCHEMA$);
    }

    /**
     * Creates a Builder by copying an existing Builder.
     * @param other The existing Builder to copy.
     */
    private Builder(org.datastream.khodza.model.avro.t_scele_public_mdl_asynchronous.AsynchronousValue.Builder other) {
      super(other);
      if (isValidValue(fields()[0], other.id)) {
        this.id = data().deepCopy(fields()[0].schema(), other.id);
        fieldSetFlags()[0] = true;
      }
      if (isValidValue(fields()[1], other.attemptid)) {
        this.attemptid = data().deepCopy(fields()[1].schema(), other.attemptid);
        fieldSetFlags()[1] = true;
      }
      if (isValidValue(fields()[2], other.cmid)) {
        this.cmid = data().deepCopy(fields()[2].schema(), other.cmid);
        fieldSetFlags()[2] = true;
      }
      if (isValidValue(fields()[3], other.courseid)) {
        this.courseid = data().deepCopy(fields()[3].schema(), other.courseid);
        fieldSetFlags()[3] = true;
      }
      if (isValidValue(fields()[4], other.userid)) {
        this.userid = data().deepCopy(fields()[4].schema(), other.userid);
        fieldSetFlags()[4] = true;
      }
      if (isValidValue(fields()[5], other.activitycode)) {
        this.activitycode = data().deepCopy(fields()[5].schema(), other.activitycode);
        fieldSetFlags()[5] = true;
      }
      if (isValidValue(fields()[6], other.activity)) {
        this.activity = data().deepCopy(fields()[6].schema(), other.activity);
        fieldSetFlags()[6] = true;
      }
      if (isValidValue(fields()[7], other.timestamp)) {
        this.timestamp = data().deepCopy(fields()[7].schema(), other.timestamp);
        fieldSetFlags()[7] = true;
      }
    }

    /**
     * Creates a Builder by copying an existing AsynchronousValue instance
     * @param other The existing instance to copy.
     */
    private Builder(org.datastream.khodza.model.avro.t_scele_public_mdl_asynchronous.AsynchronousValue other) {
            super(SCHEMA$);
      if (isValidValue(fields()[0], other.id)) {
        this.id = data().deepCopy(fields()[0].schema(), other.id);
        fieldSetFlags()[0] = true;
      }
      if (isValidValue(fields()[1], other.attemptid)) {
        this.attemptid = data().deepCopy(fields()[1].schema(), other.attemptid);
        fieldSetFlags()[1] = true;
      }
      if (isValidValue(fields()[2], other.cmid)) {
        this.cmid = data().deepCopy(fields()[2].schema(), other.cmid);
        fieldSetFlags()[2] = true;
      }
      if (isValidValue(fields()[3], other.courseid)) {
        this.courseid = data().deepCopy(fields()[3].schema(), other.courseid);
        fieldSetFlags()[3] = true;
      }
      if (isValidValue(fields()[4], other.userid)) {
        this.userid = data().deepCopy(fields()[4].schema(), other.userid);
        fieldSetFlags()[4] = true;
      }
      if (isValidValue(fields()[5], other.activitycode)) {
        this.activitycode = data().deepCopy(fields()[5].schema(), other.activitycode);
        fieldSetFlags()[5] = true;
      }
      if (isValidValue(fields()[6], other.activity)) {
        this.activity = data().deepCopy(fields()[6].schema(), other.activity);
        fieldSetFlags()[6] = true;
      }
      if (isValidValue(fields()[7], other.timestamp)) {
        this.timestamp = data().deepCopy(fields()[7].schema(), other.timestamp);
        fieldSetFlags()[7] = true;
      }
    }

    /**
      * Gets the value of the 'id' field.
      * @return The value.
      */
    public java.lang.Long getId() {
      return id;
    }

    /**
      * Sets the value of the 'id' field.
      * @param value The value of 'id'.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.t_scele_public_mdl_asynchronous.AsynchronousValue.Builder setId(long value) {
      validate(fields()[0], value);
      this.id = value;
      fieldSetFlags()[0] = true;
      return this;
    }

    /**
      * Checks whether the 'id' field has been set.
      * @return True if the 'id' field has been set, false otherwise.
      */
    public boolean hasId() {
      return fieldSetFlags()[0];
    }


    /**
      * Clears the value of the 'id' field.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.t_scele_public_mdl_asynchronous.AsynchronousValue.Builder clearId() {
      fieldSetFlags()[0] = false;
      return this;
    }

    /**
      * Gets the value of the 'attemptid' field.
      * @return The value.
      */
    public java.lang.Long getAttemptid() {
      return attemptid;
    }

    /**
      * Sets the value of the 'attemptid' field.
      * @param value The value of 'attemptid'.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.t_scele_public_mdl_asynchronous.AsynchronousValue.Builder setAttemptid(long value) {
      validate(fields()[1], value);
      this.attemptid = value;
      fieldSetFlags()[1] = true;
      return this;
    }

    /**
      * Checks whether the 'attemptid' field has been set.
      * @return True if the 'attemptid' field has been set, false otherwise.
      */
    public boolean hasAttemptid() {
      return fieldSetFlags()[1];
    }


    /**
      * Clears the value of the 'attemptid' field.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.t_scele_public_mdl_asynchronous.AsynchronousValue.Builder clearAttemptid() {
      fieldSetFlags()[1] = false;
      return this;
    }

    /**
      * Gets the value of the 'cmid' field.
      * @return The value.
      */
    public java.lang.Long getCmid() {
      return cmid;
    }

    /**
      * Sets the value of the 'cmid' field.
      * @param value The value of 'cmid'.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.t_scele_public_mdl_asynchronous.AsynchronousValue.Builder setCmid(long value) {
      validate(fields()[2], value);
      this.cmid = value;
      fieldSetFlags()[2] = true;
      return this;
    }

    /**
      * Checks whether the 'cmid' field has been set.
      * @return True if the 'cmid' field has been set, false otherwise.
      */
    public boolean hasCmid() {
      return fieldSetFlags()[2];
    }


    /**
      * Clears the value of the 'cmid' field.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.t_scele_public_mdl_asynchronous.AsynchronousValue.Builder clearCmid() {
      fieldSetFlags()[2] = false;
      return this;
    }

    /**
      * Gets the value of the 'courseid' field.
      * @return The value.
      */
    public java.lang.Long getCourseid() {
      return courseid;
    }

    /**
      * Sets the value of the 'courseid' field.
      * @param value The value of 'courseid'.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.t_scele_public_mdl_asynchronous.AsynchronousValue.Builder setCourseid(long value) {
      validate(fields()[3], value);
      this.courseid = value;
      fieldSetFlags()[3] = true;
      return this;
    }

    /**
      * Checks whether the 'courseid' field has been set.
      * @return True if the 'courseid' field has been set, false otherwise.
      */
    public boolean hasCourseid() {
      return fieldSetFlags()[3];
    }


    /**
      * Clears the value of the 'courseid' field.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.t_scele_public_mdl_asynchronous.AsynchronousValue.Builder clearCourseid() {
      fieldSetFlags()[3] = false;
      return this;
    }

    /**
      * Gets the value of the 'userid' field.
      * @return The value.
      */
    public java.lang.Long getUserid() {
      return userid;
    }

    /**
      * Sets the value of the 'userid' field.
      * @param value The value of 'userid'.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.t_scele_public_mdl_asynchronous.AsynchronousValue.Builder setUserid(long value) {
      validate(fields()[4], value);
      this.userid = value;
      fieldSetFlags()[4] = true;
      return this;
    }

    /**
      * Checks whether the 'userid' field has been set.
      * @return True if the 'userid' field has been set, false otherwise.
      */
    public boolean hasUserid() {
      return fieldSetFlags()[4];
    }


    /**
      * Clears the value of the 'userid' field.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.t_scele_public_mdl_asynchronous.AsynchronousValue.Builder clearUserid() {
      fieldSetFlags()[4] = false;
      return this;
    }

    /**
      * Gets the value of the 'activitycode' field.
      * @return The value.
      */
    public java.lang.Integer getActivitycode() {
      return activitycode;
    }

    /**
      * Sets the value of the 'activitycode' field.
      * @param value The value of 'activitycode'.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.t_scele_public_mdl_asynchronous.AsynchronousValue.Builder setActivitycode(int value) {
      validate(fields()[5], value);
      this.activitycode = value;
      fieldSetFlags()[5] = true;
      return this;
    }

    /**
      * Checks whether the 'activitycode' field has been set.
      * @return True if the 'activitycode' field has been set, false otherwise.
      */
    public boolean hasActivitycode() {
      return fieldSetFlags()[5];
    }


    /**
      * Clears the value of the 'activitycode' field.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.t_scele_public_mdl_asynchronous.AsynchronousValue.Builder clearActivitycode() {
      fieldSetFlags()[5] = false;
      return this;
    }

    /**
      * Gets the value of the 'activity' field.
      * @return The value.
      */
    public java.lang.CharSequence getActivity() {
      return activity;
    }

    /**
      * Sets the value of the 'activity' field.
      * @param value The value of 'activity'.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.t_scele_public_mdl_asynchronous.AsynchronousValue.Builder setActivity(java.lang.CharSequence value) {
      validate(fields()[6], value);
      this.activity = value;
      fieldSetFlags()[6] = true;
      return this;
    }

    /**
      * Checks whether the 'activity' field has been set.
      * @return True if the 'activity' field has been set, false otherwise.
      */
    public boolean hasActivity() {
      return fieldSetFlags()[6];
    }


    /**
      * Clears the value of the 'activity' field.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.t_scele_public_mdl_asynchronous.AsynchronousValue.Builder clearActivity() {
      activity = null;
      fieldSetFlags()[6] = false;
      return this;
    }

    /**
      * Gets the value of the 'timestamp' field.
      * @return The value.
      */
    public java.lang.Long getTimestamp() {
      return timestamp;
    }

    /**
      * Sets the value of the 'timestamp' field.
      * @param value The value of 'timestamp'.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.t_scele_public_mdl_asynchronous.AsynchronousValue.Builder setTimestamp(long value) {
      validate(fields()[7], value);
      this.timestamp = value;
      fieldSetFlags()[7] = true;
      return this;
    }

    /**
      * Checks whether the 'timestamp' field has been set.
      * @return True if the 'timestamp' field has been set, false otherwise.
      */
    public boolean hasTimestamp() {
      return fieldSetFlags()[7];
    }


    /**
      * Clears the value of the 'timestamp' field.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.t_scele_public_mdl_asynchronous.AsynchronousValue.Builder clearTimestamp() {
      fieldSetFlags()[7] = false;
      return this;
    }

    @Override
    public AsynchronousValue build() {
      try {
        AsynchronousValue record = new AsynchronousValue();
        record.id = fieldSetFlags()[0] ? this.id : (java.lang.Long) defaultValue(fields()[0]);
        record.attemptid = fieldSetFlags()[1] ? this.attemptid : (java.lang.Long) defaultValue(fields()[1]);
        record.cmid = fieldSetFlags()[2] ? this.cmid : (java.lang.Long) defaultValue(fields()[2]);
        record.courseid = fieldSetFlags()[3] ? this.courseid : (java.lang.Long) defaultValue(fields()[3]);
        record.userid = fieldSetFlags()[4] ? this.userid : (java.lang.Long) defaultValue(fields()[4]);
        record.activitycode = fieldSetFlags()[5] ? this.activitycode : (java.lang.Integer) defaultValue(fields()[5]);
        record.activity = fieldSetFlags()[6] ? this.activity : (java.lang.CharSequence) defaultValue(fields()[6]);
        record.timestamp = fieldSetFlags()[7] ? this.timestamp : (java.lang.Long) defaultValue(fields()[7]);
        return record;
      } catch (Exception e) {
        throw new org.apache.avro.AvroRuntimeException(e);
      }
    }
  }

  private static final org.apache.avro.io.DatumWriter
    WRITER$ = new org.apache.avro.specific.SpecificDatumWriter(SCHEMA$);

  @Override public void writeExternal(java.io.ObjectOutput out)
    throws java.io.IOException {
    WRITER$.write(this, SpecificData.getEncoder(out));
  }

  private static final org.apache.avro.io.DatumReader
    READER$ = new org.apache.avro.specific.SpecificDatumReader(SCHEMA$);

  @Override public void readExternal(java.io.ObjectInput in)
    throws java.io.IOException {
    READER$.read(this, SpecificData.getDecoder(in));
  }

}
